---
title: GlobalEventHandlers.onerror
slug: Web/API/GlobalEventHandlers/onerror
tags:
  - API
  - Event Handler
  - GlobalEventHandlers
  - HTML DOM
  - Property
  - Reference
---
<div>{{ApiRef("HTML DOM")}}</div>

<p>The <code><strong>onerror</strong></code> property of the {{domxref("GlobalEventHandlers")}} mixin is an {{domxref("EventHandler")}} that processes {{event("error")}} events.</p>

<p>Error events are fired at various targets for different kinds of errors:</p>

<ul>
 <li>When a <strong>JavaScript runtime error</strong> (including syntax errors and exceptions thrown within handlers) occurs, an <code><a href="/en-US/docs/Web/Events/error">error</a></code> event using interface {{domxref("ErrorEvent")}} is fired at {{domxref("window")}} and <code>window.onerror()</code> is invoked (as well as handlers attached by {{domxref("window.addEventListener")}} (not only capturing)).</li>
 <li>When a resource (such as an {{HTMLElement("img")}} or {{HTMLElement("script")}}) <strong>fails to load</strong>, an <code><a href="/en-US/docs/Web/Events/error">error</a></code> event using interface {{domxref("Event")}} is fired at the element that initiated the load, and the <code>onerror()</code> handler on the element is invoked. These error events do not bubble up to window, but can be handled with a {{domxref("window.addEventListener")}} configured with <code>useCapture</code> set to <code>true</code>.</li>
</ul>

<p>Installing a global <code>error</code> event handler is useful for automated collection of error reports.</p>

<h2 id="Syntax">Syntax</h2>

<p>For historical reasons, different arguments are passed to <code>window.onerror</code> and <code>element.onerror</code> handlers (as well as on error-type {{domxref("window.addEventListener")}} handlers).</p>

<h3 id="window.onerror">window.onerror</h3>

<pre class="brush: js notranslate">window.onerror = function(message, source, lineno, colno, error) { ... };
</pre>

<p>Function parameters:</p>

<ul>
 <li><code>message</code>: error message (string). Available as <code>event</code> (sic!) in HTML <code>onerror=""</code> handler.</li>
 <li><code>source</code>: URL of the script where the error was raised (string)</li>
 <li><code>lineno</code>: Line number where error was raised (number)</li>
 <li><code>colno</code>: Column number for the line where the error occurred (number) {{gecko_minversion_inline("31.0")}}</li>
 <li><code>error</code>: <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Error">Error Object</a> (object) {{gecko_minversion_inline("31.0")}}</li>
</ul>

<p>When the function returns <code>true</code>, this prevents the firing of the default event handler.</p>

<h3 id="window.addEventListenererror">window.addEventListener('error')</h3>

<pre class="notranslate">window.addEventListener('error', function(event) { ... })
</pre>

<p><code>event</code> of type {{domxref("ErrorEvent")}} contains all the information about the event and the error.</p>

<h3 id="element.onerror">element.onerror</h3>

<pre class="brush: js notranslate">element.onerror = function(event) { ... }
</pre>

<p><code>element.onerror</code> accepts a function with a single argument of type {{domxref("Event")}}.</p>

<p>A good example for this is when you are using an image tag, and need to specify a backup image in case the one you need is not available on the server for any reason.</p>

<pre class="brush: html notranslate"><code>&lt;img src="imagenotfound.gif" onerror="this.onerror=null;this.src='imagefound.gif';" /&gt;</code>
</pre>

<p>The reason we have the <code>this.onerror=null</code> in the function is that the browser will be stuck in an endless loop if the onerror image itself generates an error.</p>

<h2 id="Notes">Notes</h2>

<p>When an error occurs in a script, loaded from a <a href="/en-US/docs/Web/Security/Same-origin_policy">different origin</a>, the details of the error are not reported to prevent leaking information (see {{bug("363897")}}). Instead the error reported is <code><strong>"Script error."</strong></code> This behavior can be overriden in some browsers using the <code>{{htmlattrxref("crossorigin","script")}}</code> attribute on {{HTMLElement("script")}} and having the server send the appropriate <a href="/en-US/docs/Web/HTTP/Access_control_CORS">CORS</a> HTTP response headers.  A workaround is to isolate "Script error." and handle it knowing that the error detail is only viewable in the browser console and not accessible via JavaScript.</p>

<pre class="brush: js notranslate">window.onerror = function (msg, url, lineNo, columnNo, error) {
  var string = msg.toLowerCase();
  var substring = "script error";
  if (string.indexOf(substring) &gt; -1){
    alert('Script Error: See Browser Console for Detail');
  } else {
    var message = [
      'Message: ' + msg,
      'URL: ' + url,
      'Line: ' + lineNo,
      'Column: ' + columnNo,
      'Error object: ' + JSON.stringify(error)
    ].join(' - ');

    alert(message);
  }

  return false;
};</pre>

<p>When using the inline HTML markup (<code>&lt;body onerror="alert('an error occurred')"&gt;</code>), the HTML specification requires arguments passed to <code>onerror</code> to be named <code>event</code>, <code>source</code>, <code>lineno</code>, <code>colno</code>, <code>error</code>. In browsers that have not implemented this requirement, they can still be obtained via <code>arguments[0]</code> through <code>arguments[2]</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG','webappapis.html#handler-onerror','onerror')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.GlobalEventHandlers.onerror")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://blog.sentry.io/2016/01/04/client-javascript-reporting-window-onerror">Capture and report JavaScript errors with window.onerror (blog.sentry.io, 2016)</a></li>
 <li><a href="https://danlimerick.wordpress.com/2014/01/18/how-to-catch-javascript-errors-with-window-onerror-even-on-chrome-and-firefox/">How to catch JavaScript Errors with window.onerror (even on Chrome and Firefox) (danlimerick.wordpress.com, 2014)</a></li>
</ul>
